<?xml version="1.0"?>

<st-source>
<time-stamp>From VisualWorks®, 7.3.1 of April 20, 2005 on April 26, 2010 at 9:49:44 pm</time-stamp>
<!-- Changes from: PV-Support(Green.24,carry)  to: PV-Support(Green.26,carry) -->


<methods>
<class-id>PROVISO.PvRaThresholdRecord</class-id> <category>private-thresholds updating</category>

<body package="PV-Support" selector="applyBurstThreshold:currentStatistic:lastStatistic:period:">applyBurstThreshold: threshold currentStatistic: currentStatistic lastStatistic: lastStatistic period: period 
	| exceedBlock level updateBlock |
	(threshold hasBurstWarningDefined 
		and: [threshold shouldUseBurstWarningTime]) 
			ifTrue: 
				[exceedBlock := threshold warningLevelExceedBlock.
				level := threshold burstWarningLevel.
				updateBlock := [:d | self burstWarningTime: self burstWarningTime + d].
				self 
					updateDurationUsing: updateBlock
					threshold: threshold
					exceedBlock: exceedBlock
					level: level
					currentStatistic: currentStatistic
					lastStatistic: lastStatistic].
	threshold hasBurstWarningDefined 
		ifTrue: 
			[self 
				updateBurstWarningViolationThresholdsFor: currentStatistic
				from: threshold
				forPeriod: period
				lastStatistic: lastStatistic].
	(threshold hasBurstCriticalDefined 
		and: [threshold shouldUseBurstCriticalTime]) 
			ifTrue: 
				[exceedBlock := threshold criticalLevelExceedBlock.
				level := threshold burstCriticalLevel.
				updateBlock := [:d | self burstCriticalTime: self burstCriticalTime + d].
				self 
					updateDurationUsing: updateBlock
					threshold: threshold
					exceedBlock: exceedBlock
					level: level
					currentStatistic: currentStatistic
					lastStatistic: lastStatistic].
	threshold hasBurstCriticalDefined 
		ifTrue: 
			[self 
				updateBurstCriticalViolationThresholdsFor: currentStatistic
				from: threshold
				forPeriod: period
				lastStatistic: lastStatistic.
			 self 
				updateBurstCriticalResetThresholdsFor: currentStatistic
				from: threshold
				forPeriod: period
				lastStatistic: lastStatistic].
	threshold hasBurstWarningDefined 
		ifTrue: 
			[self 
				updateBurstWarningResetThresholdsFor: currentStatistic
				from: threshold
				forPeriod: period
				lastStatistic: lastStatistic].
	"Update the max percent over..."
	((self hasBurstCriticalViolation or: [self hasBurstWarningViolation]) or: [(self burstCriticalTime &gt; 0 or: [self burstWarningTime &gt; 0])])
		ifTrue: 
			[self updateBurstMaxPercentOverFor: threshold using: currentStatistic value]</body>

<body package="PV-Support" selector="updateBurstMaxPercentOverFor:using:">updateBurstMaxPercentOverFor: threshold using: currentValue

	| numerator denominator limit possibleBurstMaxPercentOver |
 
	(self hasBurstCriticalViolation or: [self burstCriticalTime &gt; 0])
		ifTrue: [ 
				(threshold burstCriticalLevelExceededBy: currentValue) 
					ifFalse: [^self].
				limit := threshold burstCriticalLevel ]
		ifFalse: [ (self hasBurstWarningViolation or: [self burstWarningTime &gt; 0])
				ifTrue: [ 
						(threshold burstWarningLevelExceededBy: currentValue) 
							ifFalse: [^self].
						limit := threshold burstWarningLevel ]].

	numerator := ( currentValue - limit ) abs.

	threshold useStandardCalculation
		ifTrue: [ denominator := limit abs ]
		ifFalse: [ threshold useNormalizedCalculation
					ifTrue: [ denominator := (threshold burstCriticalLevel - threshold burstWarningLevel) abs ]
					ifFalse:[ threshold useScaledCalculation
								ifTrue: [ denominator := threshold calculationValue ]
								ifFalse:[ "Nothing specified - not good" ^self ]]].


	(denominator = 0) 
		ifTrue: [ ^self ].

	possibleBurstMaxPercentOver := numerator / denominator.

	(possibleBurstMaxPercentOver &gt; self burstMaxPercentOver)
		ifTrue: [self burstMaxPercentOver: possibleBurstMaxPercentOver].</body>

<body package="PV-Support" selector="applyPeriodThreshold:currentStatistic:lastStatistic:period:">applyPeriodThreshold: threshold currentStatistic: currentStatistic lastStatistic: lastStatistic period: period 
	| exceedBlock level updateBlock |

	threshold hasPeriodWarningDefined 
		ifTrue: 
			[
			exceedBlock := threshold warningLevelExceedBlock.
			level := threshold periodWarningLevel.
			updateBlock := [:d | self periodWarningTime: (self periodWarningTime + d)].

			self 
				updateDurationUsing: updateBlock
				threshold: threshold
				exceedBlock: exceedBlock
				level: level
				currentStatistic: currentStatistic
				lastStatistic: lastStatistic].

	threshold hasPeriodCriticalDefined 
		ifTrue: 
			[exceedBlock := threshold criticalLevelExceedBlock.
			level := threshold periodCriticalLevel.
			updateBlock := [:d | self periodCriticalTime: (self periodCriticalTime + d)].

			self 
				updateDurationUsing: updateBlock
				threshold: threshold
				exceedBlock: exceedBlock
				level: level
				currentStatistic: currentStatistic
				lastStatistic: lastStatistic].

	self 
		updatePeriodThresholdsFor: currentStatistic
		from: threshold
		forPeriod: period.

	((self hasPeriodCriticalViolation or: [self hasPeriodWarningViolation]) or: [(self periodCriticalTime &gt; 0 or: [self periodWarningTime &gt; 0])]) 
		ifTrue: 
			[self updatePeriodMaxPercentOverFor: threshold using: currentStatistic value]</body>

<body package="PV-Support" selector="updatePeriodMaxPercentOverFor:using:">updatePeriodMaxPercentOverFor: threshold using: currentValue

	| numerator denominator limit possiblePeriodMaxPercentOver |

	(self hasPeriodCriticalViolation or: [self periodCriticalTime &gt; 0])
		ifTrue: 
			[threshold hasPeriodCriticalDefined 
				ifTrue: 
					[(threshold periodCriticalLevelExceededBy: currentValue) 
						ifFalse: [^self].
					limit := threshold periodCriticalLevel ]]
		ifFalse:
			[(self hasPeriodWarningViolation or: [self periodWarningTime &gt; 0])
				ifTrue: 
					[threshold hasPeriodWarningDefined
						ifTrue: 
							[(threshold periodWarningLevelExceededBy: currentValue) 
								ifFalse: [^self].
							limit := threshold periodWarningLevel ]]].

	limit isNil
		ifTrue: [^self].

	numerator := ( currentValue - limit ) abs.

	threshold useStandardCalculation
		ifTrue: [ denominator := limit abs ]
		ifFalse: [ threshold useNormalizedCalculation
					ifTrue: [ denominator := (threshold periodCriticalLevel - threshold periodWarningLevel) abs ]
					ifFalse:[ threshold useScaledCalculation
								ifTrue: [ denominator := threshold calculationValue ]
								ifFalse:[ "Nothing specified - not good" ^self ]]].

	(denominator = 0) 
		ifTrue: [ ^self ].

	possiblePeriodMaxPercentOver := numerator / denominator.

	(possiblePeriodMaxPercentOver &gt; self periodMaxPercentOver)
		ifTrue: [self periodMaxPercentOver: possiblePeriodMaxPercentOver].</body>
</methods>



</st-source>
